#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
#include <string.h>

#include "pin_mapping.h"
#include "common.h"
#include "sharedRAM.h"

#pragma CONST_SEG APPLICATION_VERSION 
static const uint8 version[] = "cartelBee 1.0 alfa 0";

#pragma CONST_SEG DEFAULT
static const unsigned long pAppVersion @0x0000F1BC = (unsigned long)version;

typedef unsigned char uint8_t;

#include "MCUinit.h"
#include "HT1632.h"

#include "apiframe.h"
#include "apicommon.h"
#include "apizb.h"


#define BOOTLOADER_PASSWORD "@#$%~"


int TX(unsigned char data)
{
	if (SCI2S1_TDRE)	
 		SCI2D = data;
	else
		return(-1);
    return(1);
}

int RX()
{  
	if (SCI2S1_RDRF)
		return SCI2D;
	return(-1);
}


void MCU_init(void); /* Device initialization function declaration */

void ResetHardware(APP_RESET_CAUSES Reset_Val){

    DisableInterrupts;
    AppResetCause = Reset_Val;
    if (AppResetCause == APP_CAUSE_REQUEST_SOPT1_NOT_WRITTEN){
      BLResetCause = BL_CAUSE_NOTHING;
    }
    for(;;);           //Wait for WDTimeout
    
}

void main(void)
{
static APIstruct api,apirx;
static APIdata rxdata;
APIinfo *info;
APIzsend *zs;
APIzrecv *zr;
int ret,tx=0;


	MCU_init();
	init_HT1632();
	HT1632_cls();
	//HT1632_fill(0xFF);
	//HT1632_cls();
	API_initgettingframe(&apirx);
	HT1632_string(10,"Hola!");
	IO_DIO4_ADC4_D=0;
 
	for(;;){
		__RESET_WATCHDOG();
		if(!IO_DIO4_ADC4)
			ResetHardware(APP_CAUSE_BOOTLOADER_MENU);//never returns

		if((ret=API_getframe(&apirx,0))>0){
			rxdata.len=(unsigned char) ret;
			memcpy(&rxdata.info,&apirx.frame.info,ret);
			API_initgettingframe(&apirx);
			info=&rxdata.info;
			switch(info->id){
			case API_APIZRECV:
				zr=(APIzrecv *)&info->data;

			    if(!memcmp(&zr->data,BOOTLOADER_PASSWORD,5))
		    			ResetHardware(APP_CAUSE_BOOTLOADER_MENU);//never returns

				(&zr->data)[5]=0;
				HT1632_string(0,&zr->data);
				zs=(APIzsend *)&api.frame.info.data;
				memcpy(zs->addr64,zr->addr64,8);
				zs->addr16[0]=zr->addr16[0];
				zs->addr16[1]=zr->addr16[1];
				zs->radius=0;
				zs->options=0;
				memcpy(&zs->data,"\r\n> ",4);
				api.frame.info.id=API_APIZSEND;
				API_buildframe(&api,4+sizeof(APIzsend));
				API_initsendingframe(&api);
				tx=1;
  				break;
			default:
				break;
			}
		}
		if(tx){
			if(API_sendframe(&api,0)==API_DONE)
				tx=0;
		}
	}
}
